﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace SerialPortReceiver
{
    public partial class Form1 : Form
    {
        private System.IO.Ports.SerialPort theSerialPort = new SerialPort();
        private delegate void displayDelegate(bool x);
        displayDelegate display;


        private delegate void displayDelegate2(string x);
        displayDelegate2 display2;










        //public event SerialDataReceivedEventHandler DataReceived;

        public Form1()
        {
            InitializeComponent();
            
        }

      
        private void Form1_Load(object sender, EventArgs e)
        {
            // Trage alle COMPorts in die Combobox
            try
            {
                foreach (string s in SerialPort.GetPortNames())
                {
                    comboBox1.Items.Add(s);
                }
                comboBox1.SelectedIndex = 0;

            }
            catch (Exception)
            {

            }

            button1.Enabled = true;
            button2.Enabled = false;
            textBox1.Enabled = false;

            radioButton1.Checked = false;
            groupBox1.Enabled = false;
            display = displayradiobuttonstatus;
            display2 = displayText;

        }
        public void AddDataMethod(String myString)
        {
            textBox1.AppendText(myString);
        }

        private void OpenCOMPort(string name)
        {
            try
            {
                theSerialPort.PortName = name;
                theSerialPort.BaudRate = 115200;
                theSerialPort.DataBits = 8;
                theSerialPort.StopBits = StopBits.One;
                //theSerialPort.Handshake = Handshake.None;
                theSerialPort.Open();
                button1.Enabled = false;
                button2.Enabled = true;
                comboBox1.Enabled = false;
                theSerialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceived);
                theSerialPort.PinChanged += new SerialPinChangedEventHandler(PinChanged);
                
                


            }
            catch (Exception)
            {
                MessageBox.Show("COMPort is already OPEN",
                "Important Note",
                MessageBoxButtons.OK,
                MessageBoxIcon.Exclamation,
                MessageBoxDefaultButton.Button1);
            }
        }

        private void CloseCOMPort()
        {
            try
            {
               
                if(theSerialPort.IsOpen)
                {
                    theSerialPort.Close();
                    button1.Enabled = true;
                    button2.Enabled = false;
                    comboBox1.Enabled = true;
                    theSerialPort.DataReceived -= new SerialDataReceivedEventHandler(DataReceived);
                    theSerialPort.PinChanged -= new SerialPinChangedEventHandler(PinChanged);
                   
                }

            }
            catch (Exception)
            {
                
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            OpenCOMPort(comboBox1.Text);
            textBox1.Enabled = true;
            groupBox1.Enabled = true;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            CloseCOMPort();
            textBox1.Enabled = false;
          
            groupBox1.Enabled = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            
            theSerialPort.WriteLine(textBox1.Text);
        }

        void PinChanged(object sender, SerialPinChangedEventArgs e)
        {
            SerialPinChange SerialPinChange1 = 0;
            SerialPinChange1 = e.EventType;
            switch (SerialPinChange1)
            {
               
                case SerialPinChange.CtsChanged:
                    if(theSerialPort.CtsHolding)
                    {
                        display(true);                       
                         
                        
                    }
                    else
                    {
                        display(false);
                      
                    }


                    //MessageBox.Show("CTS = " + signalState.ToString());
                    break;
                
            }
         
        }

        private void DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            var port = (SerialPort)sender;
            string data = port.ReadExisting();

            displayText(data + "\n");
        }

        void displayradiobuttonstatus(bool x)
        {
            
           
            if (radioButton1.InvokeRequired)
                radioButton1.Invoke(display, new object[] { x });
            else
                radioButton1.Checked = x;
                
           
           

        }
        
        void displayText(string x)
        {
            if (textBox1.InvokeRequired)
                textBox1.Invoke(display2, new object[] { x });
            else
                textBox1.Text += x;
        }
       
    }
}
